use std::{
    fs::File,
    io::{BufRead, BufReader},
    str::FromStr,
};

use regex::Regex;

pub fn load_input(filepath: &str) -> Result<Vec<String>, Box<dyn std::error::Error>> {
    let file = File::open(filepath)?;

    let reader = BufReader::new(file);

    let mut result: Vec<String> = vec![];

    for line in reader.lines() {
        result.push(line?);
    }

    Ok(result)
}

pub fn parse_nums<T>(s: &str) -> Vec<T>
where
    T: FromStr,
{
    let regex = Regex::new(r"(?m)(\d+)").unwrap();
    let result = regex.captures_iter(s);

    result
        .map(|e| e.get(0).unwrap().as_str())
        .flat_map(|e| e.parse::<T>())
        .collect()
}
